var widgetAPI = new Common.API.Widget();
var tvKey = new Common.API.TVKeyValue();
var plugAPI = new Common.API.Plugin();
var networkPlugin  = null;

var Input  = function(id, previousId, nextId)
{
    var imeReady = function(imeObject)
    {
        installFocusKeyCallbacks();
        installStatusCallbacks();
        Main.ready(id);
    };
    
    _g_ime.keySet = 'qwerty';
    var ime = new IMEShell(id, imeReady);
    
    var element = document.getElementById( id );
    var previousElement = document.getElementById(previousId);
    var nextElement = document.getElementById(nextId);

    var installFocusKeyCallbacks = function()
    {
        ime.setKeyFunc(tvKey.KEY_UP, function(keyCode) { previousElement.focus(); return false; } );
        ime.setKeyFunc(tvKey.KEY_DOWN, function(keyCode) { nextElement.focus(); return false; } );
        //ime.setKeyFunc(tvKey.KEY_RETURN, function(keyCode) { widgetAPI.blockNavigation(event); return false; } );
        ime.setKeyFunc(tvKey.KEY_EXIT, function(keyCode) { widgetAPI.sendExitEvent(); return false; } );
    };
    
    var installStatusCallbacks = function()
    {
        ime.setKeySetFunc("qwerty");
		ime.setAnyKeyFunc(onAnyKey);
        ime.setMaxLengthFunc(onMaxLength);
        ime.setPrevEventOnLeftFunc(onLeft);
        ime.setOnCompleteFunc(onComplete);
        ime.setEnterFunc(onEnter);
        ime.setKeyFunc(tvKey.KEY_INFO, onInfoKey);
        
        ime.setKeypadPos(680, 110);
        ime.setQWERTYPos(428, 110);     

    };
    
    
    
    var onAnyKey = function(keyCode)
    {
       alert("a key pressed");
    };
    
    var onMaxLength = function()
    {
        Main.showMessage("Maximum length of input reached in " + element.id + ", text is " + element.value);
    };
    
    var onLeft = function()
    {
        Main.showMessage("Left key pressed at start of " + element.id);
    };
    
    var onComplete = function()
    {
        Main.showMessage("Letter entry completed in " + element.id + ", text is " + element.value);
    };
    
    var onEnter = function(string)
    {
        //alert("                    answer is " + string);
        plugAPI.unregistIMEKey();
        $('#plainText').blur();
        Game.onAnswerDone(string);
        Main.enableKeys();
    };
    
    var onInfoKey = function(keyCode)
    {
        //Main.showMessage("Info key pressed in " + element.id + ", key code is " + keyCode + ", text is " + element.value);
        //ime.setString("Hello world");
        
        return true;
    };
};

var Main =
{
    elementIds : [ "plainText","nameText"],
    inputs : [ null,null],
    serial_number : null,
    ready : [ false,false]
};

Main.onLoad = function()
{
	// Enable key event processing
	alert("OnLoad: ");
	this.enableKeys();
	
	//alert(Main.serial_number);
	
	Game.onLoad();
	widgetAPI.sendReadyEvent();
	
};

Main.createInputObjects = function () {
    var index,
        previousIndex,
        nextIndex;

    for (index in this.elementIds) {
        previousIndex = index - 1;
        if (previousIndex < 0) {
            previousIndex = Main.inputs.length - 1;
        }
        nextIndex = (index + 1) % Main.inputs.length;
        Main.inputs[index] = new Input(this.elementIds[index],
                this.elementIds[previousIndex], this.elementIds[nextIndex]);
    }
};

Main.ready = function (id) {
    var ready = true,i;

    for (i in Main.elementIds) {
        if (Main.elementIds[i] == id) {
            Main.ready[i] = true;
        }

        if (Main.ready[i] == false) {
            ready = false;
        }
    }
    if (ready) {
        
    }
};


Main.onUnload = function()
{
};

Main.showMessage = function(msg)
{
	alert(msg);
};


Main.enableKeys = function()
{
	document.getElementById("anchor").focus();
};

Main.keyDown = function()
{
	var keyCode = event.keyCode;
	alert("Key pressed: " + keyCode);

	switch(keyCode)
	{
		case tvKey.KEY_RETURN:
		case tvKey.KEY_PANEL_RETURN:
			alert("RETURN: " + Game.stage);
			widgetAPI.blockNavigation(event);
			Game.returnPressed();
			break;
		case tvKey.KEY_EXIT:
			alert("EXIT");
			widgetAPI.blockNavigation(event);
			Game.exitPressed();
			break;
		case tvKey.KEY_LEFT:
			alert("LEFT");
			Game.leftPressed();
			break;
		case tvKey.KEY_RIGHT:
			alert("RIGHT");
			Game.rightPressed();
			break;
		case tvKey.KEY_UP:
			Game.upPressed();
			alert("UP");
			break;
		case tvKey.KEY_DOWN:
			Game.downPressed();
			alert("DOWN");
			break;
		case tvKey.KEY_ENTER:
		case tvKey.KEY_PANEL_ENTER:
			alert("ENTER");
			Game.enterPressed();
			break;
		case tvKey.KEY_TOOLS:
		case tvKey.KEY_PANEL_TOOLS:
			alert("TOOLS");
			Game.toolsPressed();
			break;
		case tvKey.KEY_INFO:
		case tvKey.KEY_PANEL_INFO:
			alert("INFO");
			Game.infoPressed();
			break;
		case 7:
			alert("VOLUME_UP");
			Game.volumeUpPressed();
			break;
		case 11:
			alert("VOLUME_DOWN");
			Game.volumeDownPressed();
			break;
		case tvKey.KEY_MUTE:
		case tvKey.KEY_PANEL_MUTE:
			alert("MUTE_DOWN");
			Game.mutePressed();
			break;
		default:
			alert("Unhandled key");
			break;
	}
};
