function compareAnswer(a, answer, useOnlineCheck) {

    answer = preprocess(answer);
    a = preprocess(a);
    //a = a.trim().endsWith(".") ? a.trim().substring(0, a.length - 1).trim() : a.trim();

    // прямая проверка
    
    //if (a.replaceAll("[^A-Za-z0-9А-Яа-яЁё\\?]","").trim().equalsIgnoreCase(answer.replaceAll("[^A-Za-z0-9А-Яа-яЁё\\?]","").trim()))
    if (a.replace(/[^A-Za-z0-9А-Яа-яЁё\\?]/g,"").trim().equalsIgnoreCase(answer.replace(/[^A-Za-z0-9А-Яа-яЁё\\?]/g,"").trim()))
        return 1;

    var digAnswer = parseDouble(answer);
    
    // check for digit answer
    if (digAnswer != 0 || answer == "0" ) {
        var dans = parseDouble(a);
        return dans == digAnswer ? 1 : 0;
    }

    if (answer.length <= 3)
        return a.equalsIgnoreCase(answer) ? 1 : 0;

    var stokens = getTokens(answer);
    var atokens = getTokens(a);

    var ret = 0;
    try {
        ret = compareTokens(atokens, stokens);
        /*
        if ( ret >= 0.65 ){

        } else if (contain(atokens,stokens))
            return 1;
        else if (contain(stokens,atokens))
            return 2;
        else if (stokens.length > 1 && atokens.length == 1 && atokens[0].startsWith(stokens[0])){
            // clue tokens
            var newTok = "";
            
            for (var i = 0, stok; stok = stokens[i]; i++)
                newTok += stok;
            
            var newStorkens = new Array();
            newStorkens[0] = newTok;
            
            ret = compareTokens(atokens,newStorkens);
        } else if (atokens.length > 1 && stokens.length == 1 && stokens[0].startsWith(atokens[0])){
            // clue tokens back
            var newTok = "";
            for (var i = 0, stok; stok = atokens[i]; i++)
                newTok += stok;
            var newStorkens = new Array();
            newStorkens[0] = newTok;
            ret = compareTokens(stokens,newStorkens);
        }*/

        // test with online spellcheck
        if ( useOnlineCheck && ret < 0.65 ){
            ret = compareTokens(atokens, stokens, true);
        }

    } catch (e) {
    	alert("Error: "  + e);
    }
    return ret;
}

function preprocess(answer) {
	/*
    answer = answer.toLowerCase().trim();
    answer = answer.endsWith(".") ? answer.substring(0, answer.length - 1).trim() : answer;
    answer = answer.startsWith("the ") ? answer.substring(4,answer.length) : answer;
    answer = answer.startsWith("st. ") ? "Saint " +  answer.substring(4,answer.length) : answer;
    answer = answer.startsWith("st ") ? "Saint " +  answer.substring(3,answer.length) : answer;
    answer = answer.startsWith("mt. ") ? "Mount " +  answer.substring(4,answer.length) : answer;
    answer = answer.startsWith("Mr. ") ? "Mister " +  answer.substring(5,answer.length) : answer;
    answer = answer.startsWith("mt ") ? "Mount " +  answer.substring(3,answer.length) : answer;
    answer = answer.startsWith("dr. ") ? "Doctor " +  answer.substring(4,answer.length) : answer;
    answer = answer.startsWith("dr ") ? "Doctor " +  answer.substring(3,answer.length) : answer;
    answer = answer.startsWith("an ") ? answer.substring(3,answer.length) : answer;
    answer = answer.startsWith("a ") ? answer.substring(2,answer.length) : answer;
    answer = answer.startsWith("what is ") ? answer.substring(8,answer.length) : answer;
    answer = answer.startsWith("who is ") ? answer.substring(7,answer.length) : answer;
    answer = answer.startsWith("who are ") ? answer.substring(8,answer.length) : answer;
    */
    return answer;
};

function contain(answer, input) {
    for (var i = 0, s; s = input[i]; i++){
        var yes = false;
        for (var k = 0, a; a = answer[k]; k++){
            if (a.equalsIgnoreCase(s)){
                yes = true;
                break;
            }
        }
        if (!yes)
            return false;
    }
    return true;
};

function compareTokens(atokens, stokens) {
    return compareTokens(atokens,stokens,false);
};

function compareTokens(atokens, stokens, useOnline ) {

    var overall = 0;
    for (var u = 0, atz; atz = atokens[u]; u++) {
        var results = null;
        //if (useOnline && atz.length > 2)
        //    results = doSpellCheck(atz);
        //if ( results == null )
        results = new Array(atz);

        var final_match = 0;
        for (var c = 0;c<results.length; c++) {
            var a = results[c].toCharArray();
            var max_match = 0;
            for (var k = 0, st; st = stokens[k]; k++) {
                var s = st.toCharArray();
                var matches = 0;
                var len = a.length > s.length ? a.length : s.length;
                for (var i = 0; i < s.length; i++)
                    if (i < a.length && ( s[i] == a[i] || s[i] == '?' ) )
                        matches++;
                matches = matches / len;

                // Убираем все двойные буквы
                if (matches < 1){
                    var m2 = 0;
                    var l = len;
                    var spos = 0;
                    for (var i = 0; i < s.length && spos < s.length; i++){
                        if (i < a.length ){
                            if (s[spos] == a[i])
                                m2++;

                            while ( spos + 1 < s.length && s[spos] == s[spos+1] ){
                                spos++;
                                l--;
                            }
                            spos++;
                        }
                    }
                    m2 = m2 / l;
                    matches = matches < m2 ? m2:matches;
                }

                // Убираем двойные в ответе
                if (matches < 1){
                    var m2 = 0;
                    var l = len;
                    var spos = 0;
                    for (var i = 0; i < a.length && spos < a.length; i++){
                        if (i < s.length ){
                            if (a[spos] == s[i])
                                m2++;

                            while ( spos + 1 < a.length && a[spos] == a[spos+1] ){
                                spos++;
                                l--;
                            }
                            spos++;
                        }
                    }
                    m2 = m2 / l;
                    matches = matches < m2 ? m2:matches;
                }

                // Собираем паззл из пропущенных букв.
                if (matches < 1){
                	var m2 = s.length;  // Сколько букв в правильном ответе
                	var m3 = a.length;  // Сколько букв в ответе игрока
                    if (m2 - m3 == 1){   // возможно игрок пропустил ОДНУ букву.
                    	var left = 0;
                        for (var i = 0; i < s.length; i++){   // Смотрим сколько букв совпало слева
                            if (i < a.length && s[i] == a[i])
                                left++;
                            else
                                break;
                        }

                        var dif = (int) (m2-m3);
                        var right = 0;
                        for (var i = s.length - 1; i > 0; i--){   // Смотрим сколько букв совпало справа
                            if (s[i] == a[i-dif])
                                right++;
                            else
                                break;
                        }

                        if ( left + right == m3 )  // все буквы на местах кроме одной , зачОт
                            matches = 1;
                    }
                }

                //  А вдруг одна буква лишняя в ответе
                if (matches < 1) {
                	var m2 = s.length;  // Сколько букв в правильном ответе
                	var m3 = a.length;  // Сколько букв в ответе игрока
                    if (m3 - m2 == 1){   // возможно игрок пропустил ОДНУ букву.
                    	var mtot = 0;
                    	var spos = 0;
                        for (var i = 0; i < m3; i++){   // Смотрим сколько букв совпало слева
                            if (spos < s.length && s[spos] == a[i]){
                                spos++;
                                mtot++;
                            }
                        }
                        if ( mtot == m2 )  // нашлась лишняя буква
                            matches = 1;
                    }
                }


                //  А если опечатался в одной букве но в длинном слове
                if (matches < 1 && len > 3) {
                	var m2 = s.length;  // Сколько букв в правильном ответе
                	var m3 = a.length;  // Сколько букв в ответе игрока
                    if (m3 == m2 ){   // возможно игрок пропустил ОДНУ букву.
                    	var wrongCount = 0;
                        for (var i = 0; i < m3; i++)
                            if (s[i] != a[i])
                                wrongCount ++;
                        if ( wrongCount == 1 )  // ошибся в одной буковке
                            matches = 1;
                    }
                }

                // проверяем на окончания ing или s
                if (matches < 1){
                	var atm  = cutIng(results[c]);
                	var stm = cutIng(st);
                    if (atm.length > 0 &&  atm.equals(stm))
                        matches = 1;
                }

                max_match = max_match < matches ? matches : max_match;
            }
            final_match = final_match < max_match  ? max_match : final_match;
            if ( final_match == 1)
                break;
        }

        overall += final_match;
    }

    var mlen = atokens.length > stokens.length ? atokens.length : stokens.length;
    return overall / mlen;
}

function cutIng( src) {
    var atm = src;
    /*
    if (src.endsWith("ping") && src.length > 4)
        atm = src.substring(0,src.length-4);
    else if (src.endsWith("ring") && src.length > 4)
        atm = src.substring(0,src.length-4);
    else if (src.endsWith("ling") && src.length > 4)
        atm = src.substring(0,src.length-4);
    else if (src.endsWith("ying") && src.length > 4)
        atm = src.substring(0,src.length-4);
    else if (src.endsWith("ing") && src.length > 3)
        atm = src.substring(0,src.length-3);
    else if (src.endsWith("ie") && src.length > 2)
        atm = src.substring(0,src.length-2);
    else if (src.endsWith("y") && src.length > 1)
        atm = src.substring(0,src.length-1);
    else if (src.endsWith("s") && src.length > 1)
        atm = src.substring(0,src.length-1);
    else if (src.endsWith("red") && src.length > 3)
        atm = src.substring(0,src.length-3);
    else if (src.endsWith("ped") && src.length > 3)
        atm = src.substring(0,src.length-3);
    else if (src.endsWith("ed") && src.length > 2)
        atm = src.substring(0,src.length-2);
    */
    return atm;
}

function getTokens(answer) {
    if (answer.indexOf("(") > 1)
        answer = answer.substring(0, answer.indexOf("(")).trim();
    
    /*
    answer = answer.replace(" the ","");
    answer = answer.replace(" an "," ");
    answer = answer.replace(" and "," ");
    answer = answer.replace(" of "," ");
    answer = answer.replace(" st."," Saint ");
    answer = answer.replace(" st "," Saint ");
    answer = answer.replace(" mt."," Mount ");
    answer = answer.replace(" mt "," Mount ");
    answer = answer.replace(" Mr "," Mister ");
    answer = answer.replace(" Mr. "," Mister ");
    answer = answer.replace(" dr."," Doctor ");
    answer = answer.replace(" dr "," Doctor ");
    answer = answer.replace(" or "," ");
    */
    answer = answer.replace(/[^A-Za-z0-9А-Яа-яЁё\\?]/g," ");
    answer = answer.replace(/ё/g, "е").replace(/й/g, "и").trim();
    /*
    answer = answer.replace(".", " ").replace("(", " ").replace(")", " ").replace("\"", " ").replace(";", " ")
                   .replace("\n", " ").replace(":", " ").replace(",", " ").replace("-", " ").replace("?", " ")
                   .replace("–s", " ").replace("!", " ").replace("­", " ").replace("+", " ").replace("|", " ")
                   .replace("/", " ").replace("$", " ");
    */


    var split = answer.split(" ");


    // поиск цифр прилепленых к слову
    try {
        var alength = answer.length;
        //for ( s in split){
        for (var i = 0, s; s = split[i]; i++) {
            var ss =  s.split(/([0-9].)/); 
            var newword = "";
            var count  = 0;
            
            for (var k = 0, ns; ns = ss[k]; k++) 
                if (ns.trim().length > 0 )
                    count ++;
            if (count > 1 ){
            	for (var k = 0, ns; ns = ss[k]; k++) 
                    newword += ns + " ";
                answer = answer.replace(s,newword);
            }
        }
        if (answer.length  != alength)
            split = answer.split(" ");
    } catch (e) {
    	alert(e);
    }

    var count = 0;
    for (var i = 0, s; s = split[i]; i++)
        if (s.length > 1 || s.match(/(\d.)/g) != null )
            count++;

    if (count == 0){
        if (answer.length >= 3 && answer.endsWith("s") )
            answer = answer.substring(0,answer.length-1);
        return new Array(answer);
    }

    var ret = new Array();

    var idx = 0;
    for (var i = 0, s; s = split[i]; i++)
        if (s.length > 1 || s.match(/(\d.)/g) != null ){
            if (s.length >= 3 && s.endsWith("s") )
                s = s.substring(0,s.length-1);
            ret[idx++] = s;
        }
    return ret;
};


function parseDouble(s) {
    try {
    	var ret = parseFloat(s.replace(/,/g,".")); 
        if (isNaN(ret))
        	return 0.0;
        return ret;
    } catch (e) {
    	//alert(e);
    }
    return 0;
};

function doSpellCheck(pText) {
	return null;
};

function match( left, right, cnt, startIdx) {
	
    var idxS = cnt.indexOf(left, startIdx);
    var idxE = cnt.indexOf(right, startIdx + idxS + left.length);
    if (idxS <= 0 || idxE <= 0 || idxS >= idxE)
        return null;
    return cnt.substring(idxS + left.length, idxE);
};





