var fso = new FileSystem();

var STAGE_MAIN_MENU = 0;
var STAGE_GAME = 1;
var STAGE_READY_FOR_ANSWER = 2;
var STAGE_ANSWER_DONE = 3;
var STAGE_SHOW_NAME_DIALOG = 4;
var STAGE_SHOW_OPTIONS = 5;
var STAGE_STAT = 6;
var STAGE_NO_NETWORK_DIALOG = 7;
var STAGE_EXIT_DIALOG = 8;
var STAGE_RETURN_DIALOG = 9;

var option_pos = [ 149, 196, 341, 388 ];
var option_idx = 0;
var opt_text_speed = 2;
var opt_sound = 1;
var opt_quiz = 1;
var opt_svoya = 1;
var text_speed = 80;

var snd_volume = 1;
var snd_saved_volume = 1;

var Game = {
	stage : STAGE_MAIN_MENU,
	saved_stage : -1,
	saved_view: null,
	audioElement : null,
	question : "",
	question_toshow : "",
	answer_hint : "",
	answers : [ '', '', '' ],
	len_to_show : 0,
	seconds : 0,
	hold_time : 0,
	pause : false,
	timerInterrupt : false,
	displayInterrupt : false,
	hintsUsed : 0,
	deviceId : null,
	displayName : null,
	questionId : 0,
	answerCorrect : 0,
	won : 0,
	errors : 0,
	skipped : 0,
	points : 0,
	aver_time : 0,
	rank : 0,
	type : 0,
	stat_page : 0,
	stat_per_page : 15,
	total_pages : 0,
	displayDone : false
};

Game.onLoad = function() {

	// $('#qqq').text( deviceId );

	// show logo, wait 2 second, play music then change logo to menu items.
	setTimeout(function() {
		$('#mnu_name').fadeTo(500, 0, function() {

			$('#mnu_game').fadeTo(0, 0);
			$('#mnu_settings').fadeTo(0);
			$('#mnu_exit').fadeTo(0, 0);

			$('#mnu_game').show();
			$('#mnu_settings').show();
			$('#mnu_exit').show();

			$('#mnu_game').fadeTo(1500, 1);
			$('#mnu_settings').fadeTo(1700, 1);
			$('#mnu_exit').fadeTo(2000, 1);
		});

	}, 500);

	// init options
	opt_text_speed = sf.core.localData('opt_text_speed');
	opt_sound = sf.core.localData('opt_sound');
	opt_quiz = sf.core.localData('opt_quiz');
	opt_svoya = sf.core.localData('opt_svoya');

	if (!opt_text_speed || opt_text_speed == null) {
		sf.core.localData('opt_text_speed', 2);
		sf.core.localData('opt_sound', 1);
		sf.core.localData('opt_quiz', 1);
		sf.core.localData('opt_svoya', 1);
		opt_text_speed = 2;
		opt_sound = 1;
		opt_quiz = 1;
		opt_svoya = 1;
	}

	Game.stat_page = sf.core.localData('stat_page');
	if (!Game.stat_page || Game.stat_page == null) {
		Game.stat_page = 0;
		sf.core.localData('stat_page', 0);
	}

	Game.playsnd("snd/chto_nasha_zhizn.mp3");
};

Game.playsnd = function(path) {
	if (opt_sound == 0)
		return;
	if (this.audioElement != null)
		this.audioElement.pause();

	this.audioElement = document.createElement('audio');
	this.audioElement.setAttribute('src', path);
	this.audioElement.load();
	this.audioElement.play();
	this.audioElement.volume = snd_volume;
};

Game.stopSound = function() {
	if (this.audioElement != null)
		// this.audioElement.setAttribute('src','');
		this.audioElement.pause();
};

// -------------------------------------------------- keys pressed
// -------------------------------------------------------------------------
// ------------------------------------------------------------------------------------------------------------------------------------------
Game.enterPressed = function() {
	if (this.stage == STAGE_MAIN_MENU) {

		Game.stopSound();
		this.stage = STAGE_GAME;

		this.deviceId = sf.core.localData('deviceId');

		if (!this.deviceId) {
			this.deviceId = generateGuid();
			sf.core.localData('deviceId', this.deviceId);
		}

		this.displayName = sf.core.localData('displayName');
//this.displayName = null;
		if (!this.displayName) {
			$('#logo').hide();
			$('#enter_name').show();
			this.stage = STAGE_SHOW_NAME_DIALOG; // display name dialog
			// Game.startQuestion();
			// sf.core.localData('displayName',this.deviceId);
		} else {
			$('#logo').hide();
			$('#main').show();
			Game.startQuestion();
		}
	} else if (this.stage == STAGE_READY_FOR_ANSWER) { // question write done

		$('#plainText').removeClass('input_red').removeClass('input_green').removeClass('input_brown').addClass('input_black');
		$('#answer_panel').hide();
		Game.displayIMEKeyboard();
	} else if (this.stage == STAGE_ANSWER_DONE) { // question answered, go to next question
		Game.startQuestion();
	} else if (this.stage == STAGE_SHOW_NAME_DIALOG) { // enter name
		Main.createInputObjects();
		plugAPI.registIMEKey();
		$('#nameText').val('');
		$('#nameText').focus();
	} else if (this.stage == STAGE_SHOW_OPTIONS) {

		switch (option_idx) {
		case 0:
			opt_sound = opt_sound == 0 ? 1 : 0;
			sf.core.localData('opt_sound', opt_sound);
			break;
		case 1:
			opt_text_speed++;
			if (opt_text_speed > 3)
				opt_text_speed = 1;
			sf.core.localData('opt_text_speed', opt_text_speed);
			break;
		case 2:
			opt_quiz = opt_quiz == 0 ? 1 : 0;
			sf.core.localData('opt_quiz', opt_quiz);
			break;

		case 3:
			opt_svoya = opt_svoya == 0 ? 1 : 0;
			sf.core.localData('opt_svoya', opt_svoya);
			break;
		}
		Game.setOptionChecks();
	} else if (this.stage == STAGE_EXIT_DIALOG) {
		widgetAPI.sendExitEvent();
		// widgetAPI.sendExitEvent();
	} else if (Game.stage == STAGE_RETURN_DIALOG) {
		if (this.stage == STAGE_GAME || this.stage == STAGE_READY_FOR_ANSWER)
			Game.updateScore(0, 0, 0, 0, 1);
		Game.displayInterrupt = true;
		Game.timerInterrupt = true;
		$('#logo').show();
		$('#return_dialog').hide();
		this.stage = STAGE_MAIN_MENU;
	}
};

Game.returnPressed = function() {
	if (Game.stage == STAGE_GAME || Game.stage == STAGE_READY_FOR_ANSWER || Game.stage == STAGE_ANSWER_DONE) {
		saved_stage = Game.stage;
		this.stage = STAGE_RETURN_DIALOG;
		Game.pauseGameTimer();
		$('#main').hide();
		$('#return_dialog').show();
		// Game.backToMenu();
	} else if (Game.stage == STAGE_SHOW_OPTIONS) {
		Game.backToMenu();
	} else if (Game.stage == STAGE_STAT) {
		$('#stat').hide();
		$('#main').show();
		Game.resumeGameTimer();
		this.stage = STAGE_READY_FOR_ANSWER;
	} else if (Game.stage == STAGE_NO_NETWORK_DIALOG) {
		$('#no_network').hide();
		$('#logo').show();
		this.stage = STAGE_MAIN_MENU;
	} else if (Game.stage == STAGE_MAIN_MENU) {
		widgetAPI.sendReturnEvent();
		//$('#logo').hide();
		//$('#exit_dialog').show();
		//this.stage = STAGE_EXIT_DIALOG;
	} else if (Game.stage == STAGE_EXIT_DIALOG) {
		this.stage = saved_stage;
		$('#exit_dialog').hide();
		if (this.stage == STAGE_MAIN_MENU)
			$('#logo').show();
		else if (this.stage == STAGE_GAME || this.stage == STAGE_READY_FOR_ANSWER || this.stage == STAGE_ANSWER_DONE){
			$('#main').show();
			Game.resumeGameTimer();
		} else if (this.stage == STAGE_STAT){
			$('#stat').show();
		} else if (this.stage == STAGE_SHOW_NAME_DIALOG){
			$('#enter_name').show();
		}
	} else if (Game.stage == STAGE_SHOW_NAME_DIALOG) {
		$('#enter_name').hide();
		$('#logo').show();
		this.stage = STAGE_MAIN_MENU;
	} else if (Game.stage == STAGE_RETURN_DIALOG) {
		this.stage = saved_stage;
		Game.resumeGameTimer();
		$('#main').show();
		$('#return_dialog').hide();
	}
};

Game.exitPressed = function() {
	if (Game.stage == STAGE_EXIT_DIALOG) {
		widgetAPI.sendExitEvent();
	} else if (Game.stage == STAGE_MAIN_MENU) {
		widgetAPI.sendExitEvent();
	} else {
		saved_stage = Game.stage;
		this.stage = STAGE_EXIT_DIALOG;
		Game.pauseGameTimer();
		$('#main').hide();
		$('#logo').hide();
		$('#stat').hide();
		$('#exit_dialog').show();
	}
		//Game.returnPressed();

};

Game.leftPressed = function() {
	if (this.stage == STAGE_SHOW_OPTIONS) { // options
		switch (option_idx) {
		case 1:
			opt_text_speed--;
			if (opt_text_speed < 1)
				opt_text_speed = 3;
			sf.core.localData('opt_text_speed', opt_text_speed);
			break;
		}
		Game.setOptionChecks();
	} else if (this.stage == STAGE_STAT) { // options
		if (Game.stat_page > 0) {
			Game.stat_page--;
			Game.showRankScreen();
		}
	}
};

Game.rightPressed = function() {
	if (this.stage == STAGE_READY_FOR_ANSWER) { // question write done, skip // question
		Game.updateScore(0, 0, 0, 0, 1);
		Game.timerInterrupt = true;
		$('#answer_panel').hide();
		Game.startQuestion();
	} else if (this.stage == STAGE_SHOW_NAME_DIALOG) { // do not enter name
		$('#enter_name').hide();
		Game.loadGameScreen();
	} else if (this.stage == STAGE_SHOW_OPTIONS) { // options
		switch (option_idx) {
		case 1:
			opt_text_speed++;
			if (opt_text_speed > 3)
				opt_text_speed = 1;
			sf.core.localData('opt_text_speed', opt_text_speed);
			break;
		}
		Game.setOptionChecks();
	} else if (this.stage == STAGE_STAT) { // options
		if (Game.stat_page < Game.total_pages - 1) {
			Game.stat_page++;
			Game.showRankScreen();
		}
	}
};

Game.upPressed = function() {
	if (this.stage == STAGE_SHOW_OPTIONS) {
		option_idx--;
		option_idx = option_idx < 0 ? option_pos.length - 1 : option_idx;
		$('#option_select').animate({
			top : option_pos[option_idx]
		}, 200);
	}
};

Game.downPressed = function() {
	if (this.stage == STAGE_SHOW_OPTIONS) {
		option_idx++;
		option_idx = option_idx >= option_pos.length ? 0 : option_idx;
		$('#option_select').animate({
			top : option_pos[option_idx]
		}, 200);
	}
};

Game.toolsPressed = function() {
	if (this.stage == STAGE_MAIN_MENU) { // main menu,

		// show
		this.stage = STAGE_SHOW_OPTIONS;
		$('#mnu_game').hide();
		$('#mnu_settings').hide();
		$('#mnu_exit').hide();
		$('#options').show();

		Game.setOptionChecks();

		$('#option_select').css("top", option_pos[option_idx]);

	}
};

Game.infoPressed = function() {
	if (Game.stage == STAGE_READY_FOR_ANSWER) {
		Game.showRankScreen();
	}
};

Game.volumeUpPressed = function() {
	if (snd_volume <= 0.9 ){
		snd_volume += 0.1;
		if (Game.audioElement != null)
			Game.audioElement.volume = snd_volume;
	}
};

Game.volumeDownPressed = function() {
	if (snd_volume >= 0.1 ){
		snd_volume -= 0.1;
		if (Game.audioElement != null)
			Game.audioElement.volume = snd_volume;
	}
	
};

Game.mutePressed = function() {
	
	if (snd_volume == 0){
		snd_volume = snd_saved_volume;
	} else {
		snd_saved_volume = snd_volume;
		snd_volume = 0;
	}
	
	if (Game.audioElement != null)
		Game.audioElement.volume = snd_volume;
};


// ------------------------------------------------------------------------------------------------------------------------------------------
// ------------------------------------------------------------------------------------------------------------------------------------------

Game.showRankScreen = function() {

	if (!Game.isOnline()) {
		this.stage = STAGE_NO_NETWORK_DIALOG;
		$('#main').hide();
		$('#no_network').show();
		return;
	}

	$('#main').hide();
	$('#stat').show();
	this.stage = STAGE_STAT;
	Game.pauseGameTimer();

	sf.core.localData('stat_page', Game.stat_page);

	var key = this.deviceId + ";" + this.stat_page + ";" + this.stat_per_page;
	var s = Game.downloadFile("http://www.scan-words.com/chgk_tv.aspx?g=r&k="
			+ key, function(resp) {
		alert("Rank get: " + resp);

		var parts = resp.split("~");

		var name = null;
		if (parts.length >= 3) { // have own rating
			var rl = parts[2].split(";");
			$('#stat_won_s').text(rl[4]);
			$('#stat_skip_s').text(rl[5]);
			$('#stat_lost_s').text(rl[6]);

			$('#stat_score_s').text(rl[2]);
			$('#stat_time_s').text(rl[3]);
			$('#stat_rank_s').text(rl[0]);

			name = rl[1];
		}

		var total = parseInt(parts[1]);
		$('#page_one').text((Game.stat_page + 1));
		Game.total_pages = Math.ceil(total / Game.stat_per_page);
		$('#page_total').text(Game.total_pages);

		var $clone = $('#rank_row');

		var table = document.getElementById("rank_table");
		var tableRows = table.getElementsByTagName('tr');
		var rowCount = tableRows.length;

		for ( var x = rowCount - 1; x > 0; x--)
			tableRows[x].parentNode.removeChild(tableRows[x]);

		var rt = parts[0].split("|");

		for ( var i = 0; i < rt.length; i++) {
			var rl = rt[i].split(";");

			var $cc = $clone.clone();
			$cc[0].cells[0].firstChild.data = rl[0];
			$cc[0].cells[2].firstChild.data = rl[1];
			$cc[0].cells[3].firstChild.data = rl[2];
			$cc[0].cells[4].firstChild.data = rl[3];
			$cc[0].cells[5].firstChild.data = rl[4];
			$cc[0].cells[6].firstChild.data = rl[5];
			$cc[0].cells[7].firstChild.data = rl[6];

			if (i % 2 == 0)
				$cc.attr("class", "stat_text_even");
			else
				$cc.attr("class", "stat_text_odd");

			if (name != null && rl[1] == name)
				$cc.attr("class", "stat_text_mine");

			$cc.show();
			$clone.after($cc);
			$clone = $cc;
		}

	});
};

Game.setOptionChecks = function() {
	if (opt_sound == 0)
		$('#chck_sound').attr("src", "images/check_off.png");
	else
		$('#chck_sound').attr("src", "images/check_on.png");

	switch (opt_text_speed) {
	case 1:
		$('#num_speed').attr("src", "images/chck_1.png");
		text_speed = 150;
		break;
	case 2:
		$('#num_speed').attr("src", "images/chck_2.png");
		text_speed = 80;
		break;
	case 3:
		$('#num_speed').attr("src", "images/chck_3.png");
		text_speed = 40;
		break;
	}

	if (opt_quiz == 0)
		$('#chck_quiz').attr("src", "images/check_off.png");
	else
		$('#chck_quiz').attr("src", "images/check_on.png");

	if (opt_svoya == 0)
		$('#chck_svoya').attr("src", "images/check_off.png");
	else
		$('#chck_svoya').attr("src", "images/check_on.png");
};

Game.loadGameScreen = function() {
	this.stage = STAGE_GAME;
	$('#logo').hide();
	$('#main').show();
	Game.startQuestion();
};

Game.pauseGameTimer = function() {
	Game.hold_time = new Date().getTime() / 1000;
	Game.pause = true;
};

Game.resumeGameTimer = function() {
	var pause_time = new Date().getTime() / 1000 - Game.hold_time;
	Game.seconds += pause_time;
	Game.pause = false;
};

Game.startGameTimer = function() {

	var sec_passed = new Date().getTime() / 1000 - Game.seconds;

	if (!Game.pause) {
		//alert("Sec passed: " + sec_passed);
		if (sec_passed > 300) {

			Game.updateScore(0, 0, 0, 0, 1);
			Game.timerInterrupt = true;
			$('#answer_panel').hide();
			Game.startQuestion();
			// todo: do autoskip, no answer in 5 min
		}

		if (Game.timerInterrupt)
			return;

		var _minutes = (sec_passed / 60) | 0;
		var _seconds = (sec_passed - _minutes * 60) | 0;

		var nmin = Array(Math.max(2 - String(_minutes).length + 1, 0)).join(0) + _minutes;
		var nsec = Array(Math.max(2 - String(_seconds).length + 1, 0)).join(0) + _seconds;

		$('#timer_min').text(nmin);
		$('#timer_sec').text(nsec);
	}

	//alert("Game.timerInterrupt " + Game.timerInterrupt);
	if (!Game.timerInterrupt)
		setTimeout('Game.startGameTimer();', 1000);
};

Game.startQuestion = function() {

	if (!Game.isOnline()) {
		this.stage = STAGE_NO_NETWORK_DIALOG;
		$('#main').hide();
		$('#no_network').show();
		return;
	}

	this.stage = STAGE_GAME;
	Game.answer_hint = "";
	$('#qtext').text('');
	$('#plainText').removeClass('input_red').removeClass('input_green').removeClass('input_black').addClass('input_brown');
	$('#question_area').show();
	$('#question_area_done').hide();
	$('#question_area_wrong').hide();
	$('#icn_next').hide();
	$('#rating_icon').hide();
	$('#timer_min').text("00");
	$('#timer_sec').text("00");

	var types = "0,1,2,3,4";
	if (opt_svoya == 1)
		types += ",5";
	if (opt_quiz == 1)
		types += ",7";

	var key = this.deviceId + ";" + this.questionId + ";0;0;0;"
			+ this.answerCorrect + ";;" + types;
	alert("///////////////////////                     " + key);
	var s = Game.downloadFile("http://www.scan-words.com/chgk_tv.aspx?g=q&k=" + key, function(resp) {
		// load next question

		alert(resp);
		var resparr = resp.split('~');

		//
		// alert("-------------------------------------------:" + resparr[0] +
		// "," + resparr[1] + "," + resparr[2]);
		Game.answer_hint = resparr[2].replace(/[а-яА-ЯA-Za-z0-9Ёё]/g, '-');

		Game.answers[0] = resparr[2];
		Game.answers[1] = resparr[3];
		Game.answers[2] = resparr[4];

		Game.won = resparr[7];
		Game.errors = resparr[8];
		Game.skipped = resparr[9];
		Game.points = resparr[10];
		Game.aver_time = resparr[11];
		Game.rank = parseInt(resparr[12]);
		Game.type = parseInt(resparr[13]);

		$('#stat_won').text(Game.won);
		$('#stat_skip').text(Game.skipped);
		$('#stat_lost').text(Game.errors);

		$('#stat_score').text(Game.points);
		$('#stat_time').text(Game.aver_time);
		$('#stat_rank').text(Game.rank);

		// alert("-------------------------------------------:" +
		// Game.answer_hint);
		$('#plainText').val(Game.answer_hint);

		Game.questionId = resparr[0];
		Game.answerCorrect = 0;
		Game.question = resparr[1];
		Game.question_toshow = "";
		Game.displayDone = false;
		Game.displayInterrupt = false;
		Game.displayQuestion(1);
	});
};

Game.downloadFile = function(url, success) {
	try {
		var xhr = new XMLHttpRequest();
		xhr.open('GET', url, true);
		xhr.responseType = "";
		xhr.onreadystatechange = function() {
			if (xhr.readyState == 4) {
				if (success)
					success(xhr.response);
			}
		};
		xhr.send(null);
	} catch (e) {
		alert("--------------------------------------NET ERROR: " + e);

	}
};

Game.displayQuestion = function(len) {

	if (len <= Game.question.length) {
		if (Game.displayInterrupt)
			return;
		Game.question_toshow = Game.question.substring(0, len);
		$('#qtext').text(Game.question_toshow);

		if (this.stage == STAGE_EXIT_DIALOG
				|| this.stage == STAGE_RETURN_DIALOG)
			setTimeout('Game.displayQuestion(' + len + ')', 1000);
		else
			setTimeout('Game.displayQuestion(' + (len + 1) + ')', text_speed);

	} else {
		Game.displayDone = true;
		$('#answer_panel').show();
		$('#rating_icon').show();
		this.stage = STAGE_READY_FOR_ANSWER;

		// start timer
		Game.timerInterrupt = false;
		Game.pause = false;
		Game.seconds = new Date().getTime() / 1000;
		Game.hold_time = 0;
		Game.startGameTimer();

	}
};

Game.updateScore = function(score, time, wins, lost, skip) {
	var key = this.deviceId + ";" + score + ";" + time + ";" + wins + ";"
			+ lost + ";" + skip;
	alert("Update Score: " + key);
	var s = Game.downloadFile("http://www.scan-words.com/chgk_tv.aspx?g=u&k="
			+ key, function(resp) {
		alert("Update Done: " + resp);
	});
};

// answer done - check answer and react
Game.onAnswerDone = function(answer) {
	if (this.stage == STAGE_SHOW_NAME_DIALOG) { // enter name dialog
		// var realName = answer.replace(/\W/g, '').trim();
		var realName = answer.replace(/[^а-яА-ЯA-Za-z0-9Ёё]/g, '').trim();

		if (realName.length < 3) {
			$('#name_text_error').text("Имя должно быть не короче 3х символов.");
		} else { // test name in server

			var s = Game.downloadFile("http://www.scan-words.com/chgk_tv.aspx?g=n&k="+ this.deviceId + ";" + realName,function(resp) {
								//alert("---------------------------------------------------------------------------------------Reg Name Response---: " + resp);
								if (resp == "0") { // all ok, name registered
									sf.core.localData('displayName', realName);
									$('#enter_name').hide();
									Game.loadGameScreen();
								} else if (resp == "-1") { // name used
									$('#name_text_error').text("Это имя уже занято, попробуйте ввести другое.");
								} else { // name used
									sf.core.localData('displayName', resp);
									$('#enter_name').hide();
									Game.loadGameScreen();
									// $('#name_text_error').text("Вы уже
									// зарегестрированы.");
								}
							});
			// alert("download response " + s);
		}
		return;
	}

	// enter answer
	this.stage = STAGE_ANSWER_DONE;
	Game.timerInterrupt = true;
	alert(Game.answers[0] + ',' + Game.answers[1] + ',' + Game.answers[2]);
	var test = compareAnswer(answer, Game.answers[0], false);

	$('#question_area').hide();

	var sec_passed = new Date().getTime() / 1000 - Game.seconds;

	if (test >= 0.65 ) {
		Game.answerCorrect = 1;
		$('#question_area_done').show();
		$('#plainText').removeClass('input_black').addClass('input_green');

		var _minutes = (sec_passed / 60) | 0;
		var _seconds = (sec_passed - _minutes * 60) | 0;

		$('#timer_min').text(Array(Math.max(2 - String(_minutes).length + 1, 0)).join(0) + _minutes);
		$('#timer_sec').text(Array(Math.max(2 - String(_seconds).length + 1, 0)).join(0) + _seconds);
		
		if (_minutes > 0)
			$('#ans_time').text(_minutes + " мин. " + _seconds + " сек.");
		else
			$('#ans_time').text(_seconds + " сек.");

		var msp = sec_passed > 60 ? 60 : sec_passed;
		var mPoints = (1000 - 100 * (msp / 60)) / (Game.hintsUsed + 1);

		if (Game.type == 7) {
			mPoints = mPoints / 4;
		}

		$('#ans_score').text(Math.floor(mPoints + 0.5) + "");

		Game.updateScore(Math.floor(mPoints + 0.5), sec_passed, 1, 0, 0);
	} else {
		$('#ans_correct').text(Game.answers[0]);
		$('#question_area_wrong').show();
		$('#plainText').removeClass('input_black').addClass('input_red');
		Game.updateScore(0, sec_passed, 0, 1, 0);
	}

	$('#icn_next').show();

};

Game.displayIMEKeyboard = function() {
	Main.createInputObjects();
	plugAPI.registIMEKey();

	$('#plainText').val('');
	$('#plainText').focus();
};

Game.backToMenu = function() {
	if (this.stage == STAGE_GAME || this.stage == STAGE_READY_FOR_ANSWER) {
		Game.updateScore(0, 0, 0, 0, 1);
		Game.displayInterrupt = true;
		$('#answer_panel').hide();
		$('#main').hide();
	} else if (this.stage == STAGE_ANSWER_DONE) {
		$('#icn_next').hide();
		$('#answer_panel').hide();
		$('#main').hide();
	} else if (this.stage == STAGE_SHOW_OPTIONS) {
		$('#options').hide();
		$('#mnu_game').show();
		$('#mnu_settings').show();
		$('#mnu_exit').show();
	}

	this.stage = STAGE_MAIN_MENU;
	$('#logo').show();

};

Game.isOnline = function() {
	if (!networkPlugin)
		networkPlugin = document.getElementById('pluginObjectNetwork');

	var phyConnection = networkPlugin.CheckPhysicalConnection(0);
	if (phyConnection != 1)
		phyConnection = networkPlugin.CheckPhysicalConnection(1);
	return phyConnection == 1;
};
